package org.jeecg.ctop.finance.policy.entity;

import java.io.Serializable;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * 政策审核人员配置
 * @author jeecg-boot
 * @date   2021-08-09
 * @version V1.0
 */
@Data
@TableName("ctop_cwjs_company_approval_user")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="ctop_cwjs_company_approval_user对象", description="政策审核人员配置")
public class CwjsCompanyApprovalUser {
    
	/**id*/
	@TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
	private Integer id;
	/**公司id*/
	@Excel(name = "公司id", width = 15)
    @ApiModelProperty(value = "公司id")
	private String companySubjectId;
	/**审核人员id*/
	@Excel(name = "审核人员id", width = 15)
    @ApiModelProperty(value = "审核人员id")
	private String approvalUserId;
	/**审核人员姓名*/
	@Excel(name = "审核人员姓名", width = 15)
    @ApiModelProperty(value = "审核人员姓名")
	private String approvalUserName;
	/**是否是终审（0:不是 ，1:是）*/
	@Excel(name = "是否是终审（0:不是 ，1:是）", width = 15)
    @ApiModelProperty(value = "是否是终审（0:不是 ，1:是）")
	private Integer level;
	/**删除状态（0，正常，1已删除）*/
	@Excel(name = "删除状态（0，正常，1已删除）", width = 15)
    @ApiModelProperty(value = "删除状态（0，正常，1已删除）")
	private Integer delFlag;
	/**创建时间*/
    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**更新时间*/
    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
}
