package org.jeecg.ctop.finance.policy.entity;

import java.io.Serializable;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * 政策审批记录日志
 * @author jeecg-boot
 * @date   2021-07-28
 * @version V1.0
 */
@Data
@TableName("ctop_cwjs_policy_approval_log")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="ctop_cwjs_policy_approval_log对象", description="政策审批记录日志")
public class CwjsPolicyApprovalLog {
    
	/**主键自增*/
	@TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "主键自增")
	private Integer id;
	/**policyId*/
	@Excel(name = "policyId", width = 15)
    @ApiModelProperty(value = "policyId")
	private Integer policyId;
	/**审核状态：0-审核通过  1-审核不通过*/
	@Excel(name = "审核状态：0-审核通过  1-审核不通过", width = 15)
    @ApiModelProperty(value = "审核状态：0-审核通过  1-审核不通过 2-转老板")
	private Integer approvalStatus;
	/**审核意见*/
	@Excel(name = "审核意见", width = 15)
    @ApiModelProperty(value = "审核意见")
	private String approvalContent;
	/**创建人id*/
	@Excel(name = "创建人id", width = 15)
    @ApiModelProperty(value = "创建人id")
	private String createUserId;
	/**创建时间*/
    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**更新时间*/
    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
}
