package org.jeecg.ctop.finance.policy.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.jeecg.ctop.finance.policy.entity.CwjsPolicyApprovalLog;

/**
 * 政策审批记录日志
 * @author jeecg-boot
 * 2021-07-28
 * @version V1.0
 */
public interface CwjsPolicyApprovalLogMapper extends BaseMapper<CwjsPolicyApprovalLog> {


    /**
     * 根据政策id 查询 审核意见记录
     * @param policyId
     * @param status 0-审核通过  1-审核不通过 2-转给领导'
     * @return
     */
    CwjsPolicyApprovalLog getOneByPolicyId(@Param("policyId") Integer policyId,@Param("status") Integer status);

    /**
     * 根据政策id 查询 法务最新审核意见
     * @param policyId
     * @return
     */
    CwjsPolicyApprovalLog getOneByPolicyLegalInfo(@Param("policyId") Integer policyId);

    /**
     * 根据政策id 查询 老板审核意见记录
     * @param policyId
     * @return
     */
    CwjsPolicyApprovalLog getBossOneByPolicyId(@Param("policyId") Integer policyId);
}
