package org.jeecg.ctop.finance.settlement.entity.pojo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 财务结算 结算单信息
 * zian Y
 * 2021/7/28
 **/

@Data
public class CtopCwjsSettlementFileInfo implements Serializable {

    @TableId(type = IdType.AUTO)
    /**
     * 主键id
     */
    //@TableField(exist = false)
    private Long id;

    /**
     * 广告主公司id
     */
    //@Dict(dicCode = "id", dictTable = "ctop_advertiser", dicText = "name")
    private String advertiserId;
    @TableField(exist = false)
    private String advertiserName;

    /**
     * 产品id
     */
    private String productId;
    @TableField(exist = false)
    private String productName;

    @TableField(exist = false)
    private String projectName;

    @TableField(exist = false)
    private String accountName;

    @TableField(exist = false)
    private String saleUserId;

    /**
     * 年-月
     */
    private String uploadYears;

    /**
     * 媒体类型 1-头条 2-快手 3-头条内广 4-快手内广
     */
    private Integer mediaId;

    /**
     * 文件md5
     */
    private String signature;

    /**
     * 文件路径
     */
    private String fileUrl;

    /**
     * 文件名称
     */
    private String fileName;

    /**
     * 账户id
     */
    private String accountId;


    /**
     * 删除状态（0，正常，1已删除）
     */
    private Integer delFlag;

    /**
     * 创建人id
     */
    private String createUserId;
    @TableField(exist = false)
    private String createUserName;

    /**
     * 创建时间
     */
    private Date createTime;
    @TableField(exist = false)
    private String startTime;
    @TableField(exist = false)
    private String endTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    @TableField(exist = false)
    private List<CtopCwjsSettlementFileInfo> settlementList;

}