package org.jeecg.ctop.finance.settlement.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import io.lettuce.core.dynamic.annotation.Param;
import org.jeecg.ctop.finance.settlement.entity.pojo.CtopCwjsSettlementInfo;

import java.util.List;
import java.util.Map;
import java.util.Set;


/**
 *
 * @description:
 *
 * @return:
 * @author: zianY
 * @time: 2021/7/28 17:07
 */
public interface SettlementInfoMapper extends BaseMapper<CtopCwjsSettlementInfo> {

    /**
     *查询 财务结算-账户列表
     * @param settlementInfo
     * @return
     */
    List<CtopCwjsSettlementInfo> getSettlementList(CtopCwjsSettlementInfo settlementInfo);

    /**
     *修改财务结算账户状态
     * @param id
     * @param status
     */
    void updSettlementStatusById(@Param("id") Long id, @Param("status") Integer status);

    /**
     * 根据账户id 查看财务账户
     * @param accountId
     * @return
     */
   CtopCwjsSettlementInfo getSettlementByAccountId(String accountId);

    /**
     * 删除财务结算账户
     * @param id
     */
    void deleteSettlementById(@Param("id") Long id);

    /**
     * 查询多个用户名称
     * @param userIds
     * @return
     */
    List<Map<String,Object>> getUserByIds(@Param("userIds") Set userIds);

}
