package org.jeecg.ctop.material.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * 总经理&公司记录表
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2022-02-22
 */
@Data
@TableName("sys_manager_company")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "sys_manager_company对象", description = "总经理&公司记录表")
public class SysManagerCompany {

    /**
     * id
     */
    @TableId(type = IdType.UUID)
    @ApiModelProperty(value = "id")
    private String id;
    /**
     * 经理id
     */
    @Excel(name = "经理id", width = 15)
    @ApiModelProperty(value = "经理id")
    private String manageId;
    /**
     * 部门id
     */
    @Excel(name = "部门id", width = 15)
    @ApiModelProperty(value = "部门id")
    private String companyId;
    /**
     * 公司名称
     */
    @Excel(name = "公司名称", width = 15)
    @ApiModelProperty(value = "公司名称")
    private String companyName;
    /**
     * 快手运营部ID
     */
    @Excel(name = "快手运营部ID", width = 15)
    @ApiModelProperty(value = "快手运营部ID")
    private String ksOperateId;
    /**
     * 快手设计部ID
     */
    @Excel(name = "快手设计部ID", width = 15)
    @ApiModelProperty(value = "快手设计部ID")
    private String ksDesignId;
    /**
     * 快手消耗目标值
     */
    @Excel(name = "快手消耗目标值", width = 15)
    @ApiModelProperty(value = "快手消耗目标值")
    private String ksTargetValue;
    /**
     * 头条运营部ID
     */
    @Excel(name = "头条运营部ID", width = 15)
    @ApiModelProperty(value = "头条运营部ID")
    private String ttOperateId;
    /**
     * 头条设计部ID
     */
    @Excel(name = "头条设计部ID", width = 15)
    @ApiModelProperty(value = "头条设计部ID")
    private String ttDesignId;
    /**
     * 头条消耗目标值
     */
    @Excel(name = "头条消耗目标值", width = 15)
    @ApiModelProperty(value = "头条消耗目标值")
    private String ttTargetValue;
}
