package cn.com.ctop.common.module.achievements.mapper;

import com.alibaba.fastjson.JSONObject;
import io.swagger.models.auth.In;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Set;

/**
 * 设计人员绩效
 *
 * @author: zian Y
 * @date: 2022-09-28
 * @cersion: V1.0
 */
public interface DesignerMapper{

    /**
     * 查询设计人员基础信息
     * @param userIdList 用户id
     * @param departName 部门名称
     * @return
     */
    List<JSONObject> getDesignerUserInfo(@Param("departName")String departName,@Param("userIdList") Set<String> userIdList);


    /**
     * 获取爆款视频数量
     * @param userId
     * @param roleName  角色名称
     * @param mediaType 1-头条 2-快手
     * @param yearTime 当前年份
     * @param monthTime 当前月份
     * @return
     */
    JSONObject  getHotVideoData(@Param("userId")String userId,
                                     @Param("roleName") String roleName,
                                     @Param("mediaType") Integer mediaType,
                                     @Param("yearTime") Integer yearTime,
                                     @Param("monthTime") Integer monthTime);


    /**
     *  设计人员绩效-头条
     * @param userId
     * @param yearTime
     * @param monthTime
     * @return
     */
    List<JSONObject>  getDesignerAchievementsBytedance(@Param("userId")String userId,
                                     @Param("yearTime") Integer yearTime,
                                     @Param("monthTime") Integer monthTime);


     List<JSONObject>  getDesignerAchievementsKuaishou(@Param("userId")String userId,
                                     @Param("yearTime") Integer yearTime,
                                     @Param("monthTime") Integer monthTime);




    /**
     * 查询设计 本季度 头条和快手季度消耗汇总
     * @param userId
     * @return
     */
    List<JSONObject>  getDesignerBytedanceAndKuaishouQuaterCost(@Param("userId")String userId,@Param("yearTime") Integer yearTime,
                                                                @Param("monthTime") Integer monthTime);

    /**
     * 管理消耗
     * @param userId
     * @param yearTime
     * @param monthTime
     * @return
     */
    JSONObject  getDesignerManagerLeaderCost(@Param("userId")String userId,@Param("yearTime") Integer yearTime,
                                                                @Param("monthTime") Integer monthTime);

    /**
     * 查询人员离职时间
     * @param userId
     * @return
     */
    JSONObject  getUserFrozenInfo(@Param("userId")String userId);

    /**
     * 查询人员 当前季度爆款素材数量
     * @param userId
     * @return
     */
    JSONObject  getUserHotMaterialQuarter(@Param("userId")String userId,@Param("yearTime") Integer yearTime,
                                          @Param("monthTime") Integer monthTime);

    /**
     * 绩效- 用户信息修改
     * @return
     */
    void  updateUserHappyProbability(@Param("userId")String userId,
                                           @Param("openScreenNum")String openScreenNum,
                                           @Param("paySalary")String paySalary,
                                           @Param("remarks")String remarks);


    /**
     * 根据角色查询人员
     * @param roleName
     * @return
     */
    List<JSONObject> getUserByRoleName(@Param("roleName")String roleName);


}
