package cn.com.ctop.common.module.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 代理商配置
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2022-05-17
 */
@Data
@TableName("ctop_agent_config")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_agent_config对象", description = "代理商配置")
public class AgentConfig {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * agentCode
     */
    @Excel(name = "agentCode", width = 15)
    @ApiModelProperty(value = "agentCode")
    private Long agentCode;
    /**
     * agentName
     */
    @Excel(name = "agentName", width = 15)
    @ApiModelProperty(value = "agentName")
    private String agentName;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
