package cn.com.ctop.kuaishou.modules.channel.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 渠道功能创建的应用记录
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2021-09-02
 */
@Data
@TableName("ctop_kuaishou_channel_app_info")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_kuaishou_channel_app_info对象", description = "渠道功能创建的应用记录")
public class KuaishouChannelAppInfo {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 账户id
     */
    @Excel(name = "账户id", width = 15)
    @ApiModelProperty(value = "账户id")
    private Long accountId;
    /**
     * 应用标记
     */
    @Excel(name = "应用标记", width = 15)
    @ApiModelProperty(value = "应用标记")
    private String appVersion;
    /**
     * 应用名称
     */
    @Excel(name = "应用名称", width = 15)
    @ApiModelProperty(value = "应用名称")
    private String appName;
    /**
     * 操作类型，add新增，update修改
     */
    private String type;

    /**
     * 创建类型，1新增，2，选择
     */
    private String appCreateType;
    /**
     * 应用包名
     */
    @Excel(name = "应用包名	", width = 15)
    @ApiModelProperty(value = "应用包名	")
    private String packageName;
    /**
     * 应用类型 1：Android应用下载，2：Android网页游戏，3：iOS应用下载，4：iOS网页游戏
     */
    @Excel(name = "应用类型 1：Android应用下载，2：Android网页游戏，3：iOS应用下载，4：iOS网页游戏", width = 15)
    @ApiModelProperty(value = "应用类型 1：Android应用下载，2：Android网页游戏，3：iOS应用下载，4：iOS网页游戏")
    private Integer platform;
    /**
     * 应用下载地址/网页游戏链接地址
     */
    @Excel(name = "应用下载地址/网页游戏链接地址	", width = 15)
    @ApiModelProperty(value = "应用下载地址/网页游戏链接地址	")
    private String url;
    /**
     * 是否接入快手广告监测SDK	 0：未接入，1：已接入
     */
    @Excel(name = "是否接入快手广告监测SDK	 0：未接入，1：已接入", width = 15)
    @ApiModelProperty(value = "是否接入快手广告监测SDK	 0：未接入，1：已接入")
    private Integer useSdk;
    /**
     * app隐私政策链接 安卓类应用必填
     */
    @Excel(name = "app隐私政策链接 安卓类应用必填", width = 15)
    @ApiModelProperty(value = "app隐私政策链接 安卓类应用必填")
    private String appPrivacyUrl;
    /**
     * 图标
     */
    @Excel(name = "图标", width = 15)
    @ApiModelProperty(value = "图标")
    private String imageToken;
    /**
     * 应用图标链接地址
     */
    @Excel(name = "应用图标链接地址", width = 15)
    @ApiModelProperty(value = "应用图标链接地址")
    private String appIconUrl;
    /**
     * 状态 0 待创建  1 创建中 2 创建成功 3 创建失败
     */
    @Excel(name = "状态 1 创建成功， 0 创建失败", width = 15)
    @ApiModelProperty(value = "状态 1 创建成功， 0 创建失败")
    private Integer state;
    /**
     * 备注
     */
    @Excel(name = "备注", width = 15)
    @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * app_id
     */
    @Excel(name = "app_id", width = 15)
    @ApiModelProperty(value = "app_id")
    private Long appId;
    /**
     * 创建时间
     */
    @Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @Excel(name = "修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
}
