package cn.com.ctop.kuaishou.modules.channel.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 渠道号创建策略表
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2021-09-01
 */
@Data
@TableName("ctop_kuaishou_channel_create_strategy")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_kuaishou_channel_create_strategy对象", description = "渠道号创建策略表")
public class KuaishouChannelCreateStrategy {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 使用范围，1账户，2项目
     */
    @Excel(name = "使用范围，1账户，2项目", width = 15)
    @ApiModelProperty(value = "使用范围，1账户，2项目")
    private Integer usageRange;
    /**
     * 使用范围层级,账户：account，计划：plan,组：group
     */
    @Excel(name = "使用范围层级,账户：account，计划：plan,组：group", width = 15)
    @ApiModelProperty(value = "使用范围层级,账户：account，计划：plan,组：group")
    private String usageLevel;
    /**
     * 产品id
     */
    @Excel(name = "产品id", width = 15)
    @ApiModelProperty(value = "产品id")
    private Long productId;
    /**
     * 项目id
     */
    @Excel(name = "项目id", width = 15)
    @ApiModelProperty(value = "项目id")
    private Long projectId;
    /**
     * 账户id
     */
    @Excel(name = "账户id", width = 15)
    @ApiModelProperty(value = "账户id")
    private Long accountId;
    /**
     * 创建方式 1-批量，2-excel导入
     */
    @Excel(name = "创建方式 1-批量，2-excel导入，3-自定义", width = 15)
    @ApiModelProperty(value = "创建方式 1-批量，2-excel导入，3-自定义")
    private Integer createType;
    /**
     * 创建人
     */
    @Excel(name = "创建人", width = 15)
    @ApiModelProperty(value = "创建人")
    private String userId;
    /**
     * 创建日期
     */
    @Excel(name = "创建日期", width = 15)
    @ApiModelProperty(value = "创建日期")
    private String stateDate;
    /**
     * 编号长度
     */
    @Excel(name = "编号长度", width = 15)
    @ApiModelProperty(value = "编号长度")
    private Integer numberLength;
    /**
     * 编号原始值
     */
    private String numberValue;
    /**
     * 编号最小值
     */
    @Excel(name = "编号最小值", width = 15)
    @ApiModelProperty(value = "编号最小值")
    private Integer numberMin;
    /**
     * 编号最大值
     */
    @Excel(name = "编号最大值", width = 15)
    @ApiModelProperty(value = "编号最大值")
    private Integer numberMax;
    /**
     * 渠道号
     */
    @Excel(name = "渠道号", width = 15)
    @ApiModelProperty(value = "渠道号")
    private String channelCode;
    /**
     * 渠道名称
     */
    @Excel(name = "渠道名称", width = 15)
    @ApiModelProperty(value = "渠道名称")
    private String channelName;
    /**
     * 下载链接
     */
    @Excel(name = "下载链接", width = 15)
    @ApiModelProperty(value = "下载链接")
    private String url;
    /**
     * 调起链接
     */
    @Excel(name = "调起链接", width = 15)
    @ApiModelProperty(value = "调起链接")
    private String schemaUri;
    /**
     * 第三方点击检测链接
     */
    @Excel(name = "第三方点击检测链接", width = 15)
    @ApiModelProperty(value = "第三方点击检测链接")
    private String clickTrackUrl;
    /**
     * 第三方点击按钮监测链接
     */
    @Excel(name = "第三方点击按钮监测链接", width = 15)
    @ApiModelProperty(value = "第三方点击按钮监测链接")
    private String actionbarClickUrl;
    /**
     * 是否关联单品 0:否，1:是
     */
    @Excel(name = "是否关联单品 0:否，1:是", width = 15)
    @ApiModelProperty(value = "是否关联单品 0:否，1:是")
    private Integer isHaveItem;
    /**
     * 是否循环重复使用 0:否，1:是
     */
    @Excel(name = "是否循环重复使用 0:否，1:是", width = 15)
    @ApiModelProperty(value = "是否循环重复使用 0:否，1:是")
    private Integer isCycle;
    /**
     * 应用标记
     */
    @Excel(name = "应用标记", width = 15)
    @ApiModelProperty(value = "应用标记")
    private String appVersion;
    /**
     * 应用包名
     */
    @Excel(name = "应用包名", width = 15)
    @ApiModelProperty(value = "应用包名")
    private String packageName;
    /**
     * 应用名称
     */
    @Excel(name = "应用名称", width = 15)
    @ApiModelProperty(value = "应用名称")
    private String appName;
    /**
     * 应用图标链接地址
     */
    @Excel(name = "应用图标链接地址", width = 15)
    @ApiModelProperty(value = "应用图标链接地址")
    private String appIconUrl;
    /**
     * 安卓类应用必填 隐私政策链接
     */
    private String appPrivacyUrl;
    /**
     * 图片MD5标识
     */
    @Excel(name = "图片MD5标识", width = 15)
    @ApiModelProperty(value = "图片MD5标识")
    private String imageToken;

    /**
     * 创建类型，1新增，2，选择
     */
    private String appCreateType;

    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;

    private Long appId;

    @TableField(exist = false)
    private Long channelAppInfoId;

    @TableField(exist = false)
    private String itemName;

    @TableField(exist = false)
    private String projectName;
    @TableField(exist = false)
    private String ProductName;

}
