package cn.com.ctop.kuaishou.modules.channel.entity;

import java.io.Serializable;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * 渠道号修改记录留存表
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2021-11-17
 */
@Data
@TableName("ctop_kuaishou_channel_update_record")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_kuaishou_channel_update_record对象", description = "渠道号修改记录留存表")
public class KuaishouChannelUpdateRecord {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 操作人
     */
    @Excel(name = "操作人", width = 15)
    @ApiModelProperty(value = "操作人")
    private String userId;
    /**
     * 账户id
     */
    @Excel(name = "账户id", width = 15)
    @ApiModelProperty(value = "账户id")
    private Long accountId;
    /**
     * 调起链接
     */
    @Excel(name = "调起链接", width = 15)
    @ApiModelProperty(value = "调起链接")
    private String schemaUri;
    /**
     * 第三方点击检测链接
     */
    @Excel(name = "第三方点击检测链接", width = 15)
    @ApiModelProperty(value = "第三方点击检测链接")
    private String clickTrackUrl;
    /**
     * 第三方点击按钮监测链接
     */
    @Excel(name = "第三方点击按钮监测链接", width = 15)
    @ApiModelProperty(value = "第三方点击按钮监测链接")
    private String actionbarClickUrl;
    /**
     * 是否关联单品 0:否，1:是
     */
    @Excel(name = "是否关联单品 0:否，1:是", width = 15)
    @ApiModelProperty(value = "是否关联单品 0:否，1:是")
    private Integer isHaveItem;
    /**
     * 是否循环使用 0:否，1:是
     */
    @Excel(name = "是否循环使用 0:否，1:是", width = 15)
    @ApiModelProperty(value = "是否循环使用 0:否，1:是")
    private Integer isCycle;
    /**
     * 操作时间
     */
    @Excel(name = "操作时间", width = 15)
    @ApiModelProperty(value = "操作时间")
    private String operationTime;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
