package cn.com.ctop.kuaishou.modules.clean.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 监测链接预警-日志
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2021-09-23
 */
@Data
@TableName("ctop_track_monitor_logs")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_track_monitor_logs对象", description = "监测链接预警-日志")
public class TrackMonitorLogs {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 项目id
     */
    @Excel(name = "项目id", width = 15)
    @ApiModelProperty(value = "项目id")
    private Long accountId;
    /**
     * 项目id
     */
    @Excel(name = "项目id", width = 15)
    @ApiModelProperty(value = "项目id")
    private Long unitId;
    /**
     * 错误第三方点击检测链接
     */
    @Excel(name = "错误第三方点击检测链接	", width = 15)
    @ApiModelProperty(value = "错误第三方点击检测链接	")
    private String clickTrackUrl;
    /**
     * 第三方点击按钮监测链接
     */
    @Excel(name = "第三方点击按钮监测链接", width = 15)
    @ApiModelProperty(value = "第三方点击按钮监测链接")
    private String actionbarClickUrl;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
