package cn.com.ctop.kuaishou.modules.hosting.service;

import cn.com.ctop.kuaishou.modules.hosting.entity.KuaishouHostingTask;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 智能托管-任务详情
 *
 * @author jeecg-boot
 * 2021-11-09
 * @version V1.0
 */
public interface IKuaishouHostingTaskService extends IService<KuaishouHostingTask> {

    /**
     * 任务提交
     *
     * @param templateId
     * @param videoArray
     */
    void submitTask(Long templateId, JSONArray videoArray) throws Exception;

    /**
     * 创建智能托管
     *
     * @param id
     */
    void createHosting(Long id);

    /**
     * 修改任务状态
     *
     * @param id
     * @param taskStatus
     * @param remarks
     */
    void updateStatusById(Long id, Integer taskStatus, String remarks);
}
