package cn.com.ctop.kuaishou.modules.live.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 直播数据——素材报表
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2022-03-30
 */
@Data
@TableName("ctop_live_data_material")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_live_data_material对象", description = "直播数据——素材报表")
public class LiveDataMaterial {

    /**
     * id
     */
    @TableId(type = IdType.UUID)
    @ApiModelProperty(value = "id")
    private String id;
    /**
     * 广告主id
     */
    @Excel(name = "广告主id", width = 15)
    @ApiModelProperty(value = "广告主id")
    private Long accountId;
    /**
     * 日期
     */
    @Excel(name = "日期", width = 15)
    @ApiModelProperty(value = "日期")
    private String statDate;
    /**
     * 视频ID
     */
    @Excel(name = "视频ID", width = 15)
    @ApiModelProperty(value = "视频ID")
    private String videoId;
    /**
     * 视频ID
     */
    @Excel(name = "状态，0无效，1有效", width = 15)
    @ApiModelProperty(value = "状态，0无效，1有效")
    private String state;
    /**
     * 花费（元）
     */
    @Excel(name = "花费（元）", width = 15)
    @ApiModelProperty(value = "花费（元）")
    private String charge;
    /**
     * 曝光数
     */
    @Excel(name = "曝光数", width = 15)
    @ApiModelProperty(value = "曝光数")
    private Long shows;
    /**
     * 封面曝光数
     */
    @Excel(name = "封面曝光数", width = 15)
    @ApiModelProperty(value = "封面曝光数")
    private Long photoShow;
    /**
     * 封面点击率
     */
    @Excel(name = "封面点击率", width = 15)
    @ApiModelProperty(value = "封面点击率")
    private String photoClickRatio;
    /**
     * 素材曝光数
     */
    @Excel(name = "素材曝光数", width = 15)
    @ApiModelProperty(value = "素材曝光数")
    private Long aclick;
    /**
     * 行为数
     */
    @Excel(name = "行为数", width = 15)
    @ApiModelProperty(value = "行为数")
    private Long bclick;
    /**
     * 行为率
     */
    @Excel(name = "行为率", width = 15)
    @ApiModelProperty(value = "行为率")
    private String actionRatio;
    /**
     * 作品点赞数
     */
    @Excel(name = "作品点赞数", width = 15)
    @ApiModelProperty(value = "作品点赞数")
    private Long likes;
    /**
     * 作品分享数
     */
    @Excel(name = "作品分享数", width = 15)
    @ApiModelProperty(value = "作品分享数")
    private Long shares;
    /**
     * 作品评论数
     */
    @Excel(name = "作品评论数", width = 15)
    @ApiModelProperty(value = "作品评论数")
    private Long comments;
    /**
     * COS视频URL
     */
    @Excel(name = "photoUrl", width = 15)
    @ApiModelProperty(value = "photoUrl")
    private String photoUrl;
    /**
     * 原始视频URL
     */
    @Excel(name = "videoUrl", width = 15)
    @ApiModelProperty(value = "videoUrl")
    private String videoUrl;
    /**
     * 作品3秒播放数
     */
    @Excel(name = "作品3秒播放数", width = 15)
    @ApiModelProperty(value = "作品3秒播放数")
    @TableField(value = "play_3s_count")
    private Long play3sCount;
    /**
     * 预约成功数
     */
    @Excel(name = "预约成功数", width = 15)
    @ApiModelProperty(value = "预约成功数")
    private Long eventAppointSuccess;
    /**
     * 直播观看数
     */
    @Excel(name = " 直播观看数", width = 15)
    @ApiModelProperty(value = " 直播观看数")
    private Long liveWatchCount;
    /**
     * 直接订单数
     */
    @Excel(name = " 直接订单数", width = 15)
    @ApiModelProperty(value = " 直接订单数")
    private Long liveOrderCount;
    /**
     * 直接GMV
     */
    @Excel(name = "直接GMV", width = 15)
    @ApiModelProperty(value = "直接GMV")
    private String liveGmv;
    /**
     * 直接ROI
     */
    @Excel(name = "直接ROI", width = 15)
    @ApiModelProperty(value = "直接ROI")
    private String liveRoi;
    /**
     * 涨粉数
     */
    @Excel(name = "涨粉数", width = 15)
    @ApiModelProperty(value = "涨粉数")
    private Long liveFans;
    /**
     * 次日涨粉留存数
     */
    @Excel(name = "次日涨粉留存数", width = 15)
    @ApiModelProperty(value = "次日涨粉留存数")
    private Long liveNextDayFans;
    /**
     * 次日涨粉留存率
     */
    @Excel(name = "次日涨粉留存率", width = 15)
    @ApiModelProperty(value = "次日涨粉留存率")
    private String liveNextDayFansRoi;
    /**
     * 7日涨粉留存数
     */
    @Excel(name = "7日涨粉留存数", width = 15)
    @ApiModelProperty(value = "7日涨粉留存数")
    @TableField(value = "live_fans_7d")
    private Long liveFans7d;
    /**
     * 7日涨粉留存率
     */
    @Excel(name = "7日涨粉留存率", width = 15)
    @ApiModelProperty(value = "7日涨粉留存率")
    @TableField(value = "live_fans_7d_roi")
    private String liveFans7dRoi;
    /**
     * 15日涨粉留存数
     */
    @Excel(name = "15日涨粉留存数", width = 15)
    @ApiModelProperty(value = "15日涨粉留存数")
    @TableField(value = "live_fans_15d")
    private Long liveFans15d;
    /**
     * 15日涨粉留存率
     */
    @Excel(name = "15日涨粉留存率", width = 15)
    @ApiModelProperty(value = "15日涨粉留存率")
    @TableField(value = "live_fans_15d_roi")
    private String liveFans15dRoi;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;

    @TableField(exist = false)
    private String endTime;

    @TableField(exist = false)
    private String startTime;

}
