package cn.com.ctop.kuaishou.modules.material.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 项目奖图片库
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2022-05-05
 */
@Data
@TableName("ctop_project_picture_library")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_project_picture_library对象", description = "项目奖图片库")
public class ProjectPictureLibrary {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 项目id
     */
    @Excel(name = "项目id", width = 15)
    @ApiModelProperty(value = "项目id")
    private Long projectId;
    /**
     * 项目名称
     */
    @Excel(name = "项目名称", width = 15)
    @ApiModelProperty(value = "项目名称")
    private String projectName;
    /**
     * 媒体类型 1-头条 2-快手
     */
    @Excel(name = "媒体类型 1-头条 2-快手", width = 15)
    @ApiModelProperty(value = "媒体类型 1-头条 2-快手")
    private String mediaId;
    /**
     * width
     */
    @Excel(name = "width", width = 15)
    @ApiModelProperty(value = "width")
    private String width;
    /**
     * 素材类型
     */
    @Excel(name = "素材类型", width = 15)
    @ApiModelProperty(value = "素材类型")
    private String type;
    /**
     * height
     */
    @Excel(name = "height", width = 15)
    @ApiModelProperty(value = "height")
    private String height;
    /**
     * size
     */
    @Excel(name = "size", width = 15)
    @ApiModelProperty(value = "size")
    private String size;

    /**
     * 唯一MD5码
     */
    @Excel(name = "唯一MD5码", width = 15)
    @ApiModelProperty(value = "唯一MD5码")
    private String signature;
    /**
     * 审核人员id
     */
    @Excel(name = "审核人员id", width = 15)
    @ApiModelProperty(value = "审核人员id")
    private String auditorId;
    /**
     * 设计人员id
     */
    @Excel(name = "设计人员id", width = 15)
    @ApiModelProperty(value = "设计人员id")
    private String designerId;
    /**
     * 设计名称
     */
    @Excel(name = "设计名称", width = 15)
    @ApiModelProperty(value = "设计名称")
    private String designerName;
    /**
     * 图片链接
     */
    @Excel(name = "图片链接", width = 15)
    @ApiModelProperty(value = "图片链接")
    private String url;
    /**
     * 时间
     */
    @Excel(name = "时间", width = 15)
    @ApiModelProperty(value = "时间")
    private String statDate;
    /**
     * 审核状态1-未审核,2-审核通过,3-审核拒绝
     */
    @Excel(name = "审核状态1-未审核,2-审核通过,3-审核拒绝", width = 15)
    @ApiModelProperty(value = "审核状态1-未审核,2-审核通过,3-审核拒绝")
    private String auditState;
    /**
     * 审核时间
     */
    @Excel(name = "审核时间", width = 15)
    @ApiModelProperty(value = "审核时间")
    private String auditTime;
    /**
     * 审核说明
     */
    @Excel(name = "审核说明", width = 15)
    @ApiModelProperty(value = "审核说明")
    private String auditMessage;
    /**
     * 图片创建人id
     */
    @Excel(name = "图片创建人id", width = 15)
    @ApiModelProperty(value = "图片创建人id")
    private String userId;
    /**
     * 创建时间
     */
    @Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @Excel(name = "修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
}
