package org.jeecg.modules.duxiaoman.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;

import java.util.Date;

/**
 * 度小满素材信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2022-08-15
 */
@Data
@TableName("ctop_duxiaoman_material_info")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_duxiaoman_material_info对象", description = "度小满素材信息")
public class DuxiaomanMaterialInfo {

    /**
     * id
     */
    @TableId(type = IdType.UUID)
    @ApiModelProperty(value = "id")
    private String id;
    /**
     * signature
     */
    @Excel(name = "signature", width = 15)
    @ApiModelProperty(value = "signature")
    private String signature;
    /**
     * 上传日期
     */
    @Excel(name = "statDate", width = 15)
    @ApiModelProperty(value = "statDate")
    private String statDate;
    /**
     * url
     */
    @Excel(name = "url", width = 15)
    @ApiModelProperty(value = "url")
    private String url;

    /**
     * 封面url
     */
    @Excel(name = "coverUrl", width = 15)
    @ApiModelProperty(value = "coverUrl")
    private String coverUrl;
    /**
     * 报备文件id
     */
    @Excel(name = "fileId", width = 15)
    @ApiModelProperty(value = "fileId")
    private String fileId;
    /**
     * 审核任务ID
     */
    @Excel(name = "auditTaskId", width = 15)
    @ApiModelProperty(value = "auditTaskId")
    private String auditTaskId;
    /**
     * 素材名称
     */
    @Excel(name = "素材名称", width = 15)
    @ApiModelProperty(value = "素材名称")
    private String materialName;
    /**
     * 项目id
     */
    @Excel(name = "项目id", width = 15)
    @ApiModelProperty(value = "项目id")
    private Long projectId;
    /**
     * 项目名称
     */
    @Excel(name = "项目名称", width = 15)
    @ApiModelProperty(value = "项目名称")
    private String projectName;
    /**
     * 产品id
     */
    @Excel(name = "产品id", width = 15)
    @ApiModelProperty(value = "产品id")
    private Long productId;
    /**
     * 产品名
     */
    @Excel(name = "产品名", width = 15)
    @ApiModelProperty(value = "产品名")
    private String productName;
    /**
     * 创建人id
     */
    @Excel(name = "创建人id", width = 15)
    @ApiModelProperty(value = "创建人id")
    private String userId;
    /**
     * 审核人
     */
    @Excel(name = "审核人", width = 15)
    @ApiModelProperty(value = "审核人")
    private String auditorId;
    /**
     * 0-待审核,1-待上传,2-审批中,3-审核通过,4-审核不通过,5-预审核，6-预审核拒绝，7-上传成功，8-上传失败，101待提交
     */
    @Excel(name = "0-待审核,1-待上传,2-审批中,3-审核通过,4-审核不通过,5-预审核，6-预审核拒绝，7-上传成功，8-上传失败，101待提交", width = 15)
    @ApiModelProperty(value = "0-待审核,1-待上传,2-审批中,3-审核通过,4-审核不通过,5-预审核，6-预审核拒绝，7-上传成功，8-上传失败")
    private Integer status;
    /**
     * 通过审核时间
     */
    @Excel(name = "通过审核时间", width = 15)
    @ApiModelProperty(value = "通过审核时间")
    private String confirmTime;
    /**
     * 拒绝原因
     */
    @Excel(name = "拒绝原因", width = 15)
    @ApiModelProperty(value = "拒绝原因")
    private String refuseReason;

    /**
     * 文案
     */
    @Excel(name = "文案", width = 15)
    @ApiModelProperty(value = "文案")
    private String creativeCopywriter;
    /**
     * 素材类型,VIDEO-视频，SCRIPT-脚本
     */
    @Excel(name = "素材类型", width = 15)
    @ApiModelProperty(value = "素材类型")
    private String type;

    /**
     * 驳回图片ID
     */
    @Excel(name = "驳回图片ID", width = 15)
    @ApiModelProperty(value = "驳回图片ID")
    private String auditImagesId;
    /**
     * 视频描述
     */
    @Excel(name = "视频描述", width = 15)
    @ApiModelProperty(value = "视频描述")
    private String materialDescribe;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;

    /**
     * 开始时间
     */
    @TableField(exist = false)
    private String startDate;

    /**
     * 结束时间
     */
    @TableField(exist = false)
    private String endDate;
}
