package cn.com.ctop.common.service;


import cn.com.ctop.common.entity.Project;
import cn.com.ctop.common.entity.ProjectMember;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.IService;
import org.jeecg.common.system.entity.SysUser;

import java.util.List;
import java.util.Map;

/**
 * 项目成员
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-11-19
 */
public interface IProjectMemberService extends IService<ProjectMember> {
    List<Long> selectProjectsByUserId(String userId);

    List<Long> selectProductsByUserId(String userId);

    List<ProjectMember> getProjects(List<Integer> mediaIds);

    List<Map<String, Object>> getProjectAccountByUserId(String userId, String mediaType);

    ProjectMember getProjectByParams(Long targetProject, String userId);

    List<ProjectMember> getOwnProjects(List<Integer> mediaIds);

    List<ProjectMember> getSaleOwnProjects(List<Integer> mediaIds);

    List<Long> getProjectByMap(String userId);

    List<Project> selectListByUserId(String userId);

    List<Long> getProjectByAccountIds(JSONArray accountIds);

    List<JSONObject> getProjectByUserIdAndMediaIds(List<String> userIds, List<Integer> mediaIds);

    List<Map<String, Object>> getAllProjectAccount(String mediaType);

    List<Long> getProductByAccountIds(JSONArray accountIds);

    List<Long> getProjectIdsByProductId(Long productId, String userId);


}
