package cn.com.ctop.common.service;

import cn.com.ctop.common.entity.SysRole;
import com.baomidou.mybatisplus.extension.service.IService;
import org.jeecg.common.api.vo.Result;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * <p>
 * 角色表 服务类
 * </p>
 *
 * @Author scott
 * @since 2018-12-19
 */
public interface ISysRoleService extends IService<SysRole> {


    /**
     * 删除角色
     * @param roleid
     * @return
     */
    public boolean deleteRole(String roleid);

    /**
     * 批量删除角色
     * @param roleids
     * @return
     */
    public boolean deleteBatchRole(String[] roleids);


    /**
     * 根据userId获取角色code
     * @param userId
     * @return
     */
    String getRoleCodeByUserId(String userId);
    /**
     * 查询分公司下人员
     *
     * @param roleCode CompanyManager——分公司总经理，查询分公司所有人员
     * @param roleCode bytedanceDirector——头条总监，查询分公司所有头条部门人员
     * @param roleCode kuaishouDirector——快手总监，查询分公司所有快手部门人员
     */
    List<String> getCompanyUsers(String roleCode, String userId);
}
