package cn.com.ctop.common.service.impl;


import cn.com.ctop.common.entity.UserCompany;
import cn.com.ctop.common.mapper.UserCompanyMapper;
import cn.com.ctop.common.service.IUserCompanyService;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.entity.SysDepart;
import org.jeecg.common.system.entity.SysUser;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 用户够公司
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-11-14
 */
@Slf4j
@Service
public class UserCompanyServiceImpl extends ServiceImpl<UserCompanyMapper, UserCompany> implements IUserCompanyService {
    @Resource
    private UserCompanyMapper userCompanyMapper;

    @Override
    public List<String> getUserIdListByCompanyId(String companyId) {
        return userCompanyMapper.getUserIdListByCompanyId(companyId);
    }

    @Override
    public UserCompany getByUserId(String userId) {
        return userCompanyMapper.queryOne(userId);
    }

}
