package cn.com.ctop.report.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;

@Data
@TableName("kuaishou_material_video_report_daily_dw")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class KuaishouMaterialVideoReportDailyDw {
    private Long accountId;
    private Long statDate;
    private int hour;
    /**
     * 项目id
     */
    private Long projectId;
    /**
     * 产品id
     */
    private Long productId;
    /**
     * 广告主id
     */
    private String advertiserId;
    /**
     * 公司id
     */
    private String companyId;
    /**
     * 账户名称
     */
    private String accountName;
    /**
     * 项目名称
     */
    private String projectName;
    /**
     * 广告主名称
     */
    private String advertiserName;
    /**
     * 公司名称
     */
    private String companyName;
    /**
     * 销售id
     */
    private String saleId;
    /**
     * 运营id
     */
    private String userId;
    /**
     * 机构编码
     */
    private String orgCode;
    private Long campaignId;
    private String campaignName;
    private Long unitId ;
    private String unitName;
    private Long creativeId ;
    private String  creativeName;
    /**
     * 花费（元）
     */
    private BigDecimal charge;
    /**
     * 封面曝光数
     */
    private Long show;
    /**
     * 封面点击数
     */
    private Long photoClick;
    /**
     * 素材曝光数
     */
    private Long aclick;
    /**
     * 行为数
     */
    private Long bclick;
    /**
     * 封面点击率
     */
    private BigDecimal photoClickRatio;
    /**
     * 3s播放率
     */
    private BigDecimal play3sRatio;
    /**
     * 行为率
     */
    private BigDecimal actionRatio;
    /**
     * 平均千次曝光花费（元）
     */
    private BigDecimal impression1kCost;
    /**
     * 平均点击单价（元）
     */
    private BigDecimal photoClickCost;
    /**
     * 平均行为单价（元）
     */
    private BigDecimal actionCost;
    /**
     * 分享数
     */
    private Long share;
    /**
     * 评论数
     */
    private Long comment;
    /**
     * 点赞数
     */
    private Long like;
    /**
     * 新增关注数
     */
    private Long follow;
    /**
     * 取消关注数
     */
    private Long cancelFollow;
    /**
     * 举报数
     */
    private Long report;
    /**
     * 拉黑数
     */
    private Long block;
    /**
     * 减少此类作品数
     */
    private Long negative;
    /**
     * 提交按钮点击数（历史字段，同下方“表单提交数”，预计年底删除该字段）
     */
    private Long submit;
    /**
     * 应用下载数据-安卓下载开始数
     */
    private Long downloadStarted;
    /**
     * 应用下载数据-安卓下载完成数
     */
    private Long downloadCompleted;
    /**
     * 应用下载数据-激活数
     */
    private Long activation;
    /**
     * 应用下载数据-首日付费次数
     */
    private Long eventPayFirstDay;
    /**
     * 应用下载数据-首日付费金额
     */
    private BigDecimal eventPayPurchaseAmountFirstDay;
    /**
     * 应用下载数据-首日ROI
     */
    private BigDecimal eventPayFirstDayRoi;
    /**
     * 应用下载数据-付费次数
     */
    private Long eventPay;
    /**
     * 应用下载数据-付费金额
     */
    private BigDecimal eventPayPurchaseAmount;
    /**
     * 应用下载数据-ROI
     */
    private BigDecimal eventPayRoi;
    /**
     * 应用下载数据-注册数
     */
    private Long eventRegister;
    /**
     * 应用下载数据-注册成本
     */
    private BigDecimal eventRegisterCost;
    /**
     * 应用下载数据-注册率
     */
    private BigDecimal eventRegisterRatio;
    /**
     * 应用下载数据-完件数
     */
    private Long eventJinJianApp;
    /**
     * 应用下载数据-完件成本
     */
    private BigDecimal eventJinJianAppCost;
    /**
     * 应用下载数据-授信数
     */
    private Long eventCreditGrantApp;
    /**
     * 应用下载数据-授信成本
     */
    private BigDecimal eventCreditGrantAppCost;
    /**
     * 应用下载数据-授信率
     */
    private BigDecimal eventCreditGrantAppRatio;
    /**
     * 应用下载数据-付款成功数
     */
    private Long eventOrderPaid;
    /**
     * 应用下载数据-付款成功金额
     */
    private BigDecimal eventOrderPaidPurchaseAmount;
    /**
     * 应用下载数据-单次付款成本
     */
    private BigDecimal eventOrderPaidCost;
    /**
     * 应用下载数据-次留数（仅支持分日查询）
     */
    private Long eventNextDayStay;
    /**
     * 应用下载数据-次留成本（仅支持分日查询）
     */
    private BigDecimal eventNextDayStayCost;
    /**
     * 应用下载数据-次留率（仅支持分日查询）
     */
    private BigDecimal eventNextDayStayRatio;
    /**
     * 落地页数据-表单提交数
     */
    private Long formCount;
    /**
     * 落地页数据-表单提交单价
     */
    private BigDecimal formCost;
    /**
     * 落地页数据-表单提交点击率
     */
    private BigDecimal formActionRatio;
    /**
     * 落地页数据-落地页完件数
     */
    private Long eventJinJianLandingPage;
    /**
     * 落地页数据-落地页完件成本
     */
    private BigDecimal eventJinJianLandingPageCost;
    /**
     * 落地页数据-落地页授信数
     */
    private Long eventCreditGrantLandingPage;
    /**
     * 落地页数据-落地页授信成本
     */
    private BigDecimal eventCreditGrantLandingPageCost;
    /**
     * 落地页数据-落地页授信率
     */
    private BigDecimal eventCreditGrantLandingPageRatio;
    /**
     * 落地页数据-有效线索数
     */
    private Long eventValidClues;
    /**
     * 落地页数据-有效线索成本
     */
    private BigDecimal eventValidCluesCost;
    /**
     * 微信复制数
     */
    private Long eventAddWechat;
    /**
     * 微信复制成本
     */
    private BigDecimal eventAddWechatCost;
    /**
     * 微信复制率
     */
    private BigDecimal eventAddWechatRatio;
    /**
     * 智能电话-确认接通数
     */
    private Long eventGetThrough;
    /**
     * 智能电话-确认接通成本
     */
    private BigDecimal eventGetThroughCost;
    /**
     * 智能电话-确认接通率
     */
    private BigDecimal eventGetThroughRatio;
    /**
     * 唤醒应用数
     */
    private Long eventAppInvoked;
    /**
     * 唤醒应用成本
     */
    private BigDecimal eventAppInvokedCost;
    /**
     * 唤醒应用率
     */
    private BigDecimal eventAppInvokedRatio;
    /**
     * 落地页授信率
     */
    private BigDecimal eventCreditGrantLandingRatio;
    /**
     * 5s播放率
     */
    private BigDecimal play5sRatio;
    /**
     * 完播率
     */
    private BigDecimal playEndRatio;
    /**
     * 新增付费人数
     */
    private BigDecimal eventNewUserPay;
    /**
     * 新增付费人数成本
     */
    private BigDecimal eventNewUserPayCost;
    /**
     * 新增付费人数率
     */
    private BigDecimal eventNewUserPayRatio;
    /**
     * 平均千次素材曝光花费(元)
     */
    private BigDecimal click1kCost;
    /**
     * 商品成交数
     */
    private Long adProductCnt;
    /**
     * 商品访问数
     */
    private Long eventGoodsView;
    /**
     * 涨粉量
     */
    private Long merchantRecoFans;
    /**
     * 小店推广roi
     */
    private BigDecimal eventOrderAmountRoi;
    /**
     * 商品访问成本
     */
    private BigDecimal eventGoodsViewCost;
    /**
     * 涨粉成本
     */
    private BigDecimal merchantRecoFansCost;
    /**
     * 按钮点击数
     */
    private Long eventButtonClick;
    /**
     * 按钮点击成本
     */
    private BigDecimal eventButtonClickCost;
    /**
     * 按钮点击率
     */
    private BigDecimal eventButtonClickRatio;
    /**
     * 订单支付率
     */
    private BigDecimal eventOrderPaidRoi;
    /**
     * 新增完件人数
     */
    private Long eventNewUserJinjianApp;
    /**
     * 新增完件成本
     */
    private BigDecimal eventNewUserJinjianAppCost;
    /**
     * 新增完件人数率
     */
    private BigDecimal eventNewUserJinjianAppRoi;
    /**
     * 新增授信人数
     */
    private Long eventNewUserCreditGrantApp;
    /**
     * 新增授信人数成本
     */
    private BigDecimal eventNewUserCreditGrantAppCost;
    /**
     * 新增授信人数率
     */
    private BigDecimal eventNewUserCreditGrantAppRoi;

    private Long eventNewUserJinjianPage;
    private BigDecimal eventNewUserJinjianPageCost;
    private BigDecimal eventNewUserJinjianPageRoi;
    private Long eventNewUserCreditGrantPage;
    private BigDecimal eventNewUserCreditGrantPageCost;
    private BigDecimal eventNewUserCreditGrantPageRoi;
    /**
     * 预约表单数
     */
    private Long eventAppointForm;
    /**
     * 预约表单点击成本
     */
    private BigDecimal eventAppointFormCost;
    /**
     * 预约表单点击率
     */
    private BigDecimal eventAppointFormRatio;
    /**
     * 预约跳转点击数
     */
    private Long eventAppointJumpClick;
    /**
     * 预约跳转点击成本
     */
    private BigDecimal eventAppointJumpClickCost;
    /**
     * 预约跳转点击率
     */
    private BigDecimal eventAppointJumpClickRatio;
    /**
     * 联盟广告收入
     */
    private Long unionEventPayPurchaseAmount7d;
    /**
     * 联盟变现ROI
     */
    private BigDecimal unionEventPayPurchaseAmount7dRoi;

    private String placementType;

    private String adScene;

    private Long eventOrderSuccessed;
    private BigDecimal adPhotoPlayed10sRatio;
    private BigDecimal keyActionCost;
    /**
     * 添加购物车成本
     */
    private BigDecimal eventAddShoppingCartCost;

    /**
     * 广告观看次数转化率
     */
    private BigDecimal eventAdWatchTimesRatio;
    private BigDecimal eventOutboundCallCost;
    private Long eventOutboundCall;
    private BigDecimal actionNewRatio;

    /**
     * 广告观看
     */
    private Long eventWatchAppAd;
    /**
     * 落地页多转化成本
     */
    private BigDecimal eventMultiConversionCost;
    private Long eventPhoneCardActivate;
    private BigDecimal adPhotoPlayed75percentRatio;
    private BigDecimal keyActionRatio;
    /**
     * 广告观看次数成本
     */
    private BigDecimal eventAdWatchTimesCost;
    /**
     * 添加购物车数
     */
    private Long eventAddShoppingCart;
    private Long keyAction;

    /**
     * 落地页多转化次数
     */
    private Long eventMultiConversion;
    private Long eventWechatConnected;
    /**
     * 附加组件表单提交
     */
    private Long eventDspGiftForm;
    private Long eventIntentionConfirmed;
    private Long eventPhoneGetThrough;
    /**
     * 落地页多转化率
     */
    private BigDecimal eventMultiConversionRatio;
    private BigDecimal eventMeasurementHouse;
    private BigDecimal adPhotoPlayed2sRatio;
    private BigDecimal eventOutboundCallRatio;
    /**
     * 广告观看次数
     */
    private Long eventAdWatchTimes;
}
